<?php
/*
Plugin Name: Thank Me Later
Plugin URI: http://making-the-web.com/thank-me-later/
Description: Sends a customizable "thank you" message after (a few hours, few days, weeks) a comment has been posted. This acts a reminder of your blog and can bring "one-time" readers back
Author: Brendon Boshell
Version: 1.5.1
Author URI: http://making-the-web.com
*/

/*
	These are some variables that will be used through out the script. They will be loaded with values at initialization.
	
	They are not here for you to change. Please change options from the OPTIONS PAGE
	
*/

$_TML_Version           = "1.5.1";

$_TML_Table             = $wpdb->prefix . "thankmelater"; // you should not change this value
$_TML_SentTable         = $wpdb->prefix . "thankmelater_sent"; // you should not change this value
$_TML_hasOptions        = false;
$_TML_sendafter         = false;
$_TML_giveortake        = false;
$_TML_enabled           = false;
$_TML_message_from      = false;
$_TML_message_fromemail = false;
$_TML_message_subject   = false;
$_TML_message_message   = false;
$_TML_processGroupSize  = false;
$_TML_updateInterval    = false;
$_TML_maxSend           = false;
$_TML_sendGap           = false;

$_TML_promote           = false;

$_TML_html              = false;
$_TML_bases             = false;

$_TML_restrict_tagsType = false; // 0/false for "include all tags excluding the following". 1 for "only include the following tags"
$_TML_restrict_tagsArr  = false; // associative array holding tags

$_TML_restrict_categoriesType = false; // 0/false for "include all categories excluding the following". 1 for "only include the following categories"
$_TML_restrict_categoriesArr  = false; // associative array holding categories

/* 
 *	_TML_history()
 *	Shows the history page.
*/
function _TML_history() {
	global $wpdb, $_TML_SentTable, $_TML_Table, $comment;
	
	/* Much of this function is basec on code found in /wp-admin/includes/template.php, in _wp_get_comment_list() */
	
	// How many email addresses have we sent to in total?
	$result = $wpdb->get_row("SELECT COUNT(id) FROM ".$_TML_SentTable." WHERE `actualsent` != 0", ARRAY_N);
	$total = $result[0];
	
	$itemsperpage = 50;
	$page         = (isset($_GET['tml_page'])) ? (int)$_GET['tml_page'] : 1;
	
	$page_links = paginate_links( array(
		'base' => add_query_arg('tml_page', '%#%'),
		'format' => '',
		'total' => ceil($total / $itemsperpage),
		'current' => $page
	));
	
	$offset = floor($itemsperpage*$page)-$itemsperpage; // Where to start loading records from.
	
	?>
	
		<div class="wrap">
		
			<h2><?php _e('Thank Me Later Sent History', 'thankmelater'); ?></h2>
			
			<?php _TML_addSubMenu(); ?>
			
			<div class="tablenav" style="height: 40px;">
			
			<?php if($page_links) { echo "<div class='tablenav-pages'>$page_links</div>"; } ?>
			
			<br class="clear" />
			
			</div>
			
			<table class="widefat">
				<thead>
				  <tr>
					<th scope="col" width="45%"><?php _e('Email', 'thankmelater'); ?></th>
					<th scope="col" width="90"><?php _e('Emails Sent', 'thankmelater'); ?>*</th>
					<th scope="col"><?php _e('Last Comment Date', 'thankmelater'); ?></th>
				  </tr>
				</thead>
				<tbody id="the-comment-list" class="list:comment">
				<?php
				
					$results = $wpdb->get_results("SELECT id, email, actualsent, lastcomment FROM ".$_TML_SentTable."  WHERE `actualsent` != 0 LIMIT $offset, $itemsperpage");
			
					foreach($results as $result) { // show list of emails...
						
						?>
						<tr id="pending-<?php echo $result->id; ?>" class='' <?php if($result->actualsent < 1) { ?>style="color: #AAAAAA;"<?php } ?>>
							<td>
								<?php echo $result->email; ?>
							</td>
							<td>
								<?php echo $result->actualsent; ?>
							</td>
							<td><?php echo date(__('Y/m/d \\a\\t g:i A', 'thankmelater'), $result->lastcomment); ?></td>
						</tr>

						<?php
					}
					
				?>
				</tbody>
			</table>
			
		</div>
	
	<?php
	
	/* END */
	
} /* _TML_history() */

/* 
 *	_TML_sched()
 *	Shows the scheduled sents page
 *
 *	Similar format to _TML_history()
*/
function _TML_sched() {
	global $wpdb, $_TML_SentTable, $_TML_Table, $comment;
	
	/* NOTE:
	
		THIS FUNCTION MAY BE INTENSIVE ON THE DATABASE. ALTHOUGH PAGINATION IS IMPLEMENTED, RECORDS HAVE TO BE TAKEN FROM 0
		FOR EVERY PAGE DUE TO LIMITATIONS OF THE TABLE'S STRUCTURE.
		
		REVISION BEING CONSIDERED
	
	*/
	
	/* Much of this function is basec on code found in /wp-admin/includes/template.php, in _wp_get_comment_list() */
	
	$result = $wpdb->get_row("SELECT COUNT(id) FROM ".$_TML_Table, ARRAY_N);
	$total = $result[0];
	
	$itemsperpage = 20;
	$page         = (isset($_GET['tml_page'])) ? (int)$_GET['tml_page'] : 1;
	
	$offset = floor($itemsperpage*$page)-$itemsperpage;
	
	$timeOffset = get_option("gmt_offset")*3600;
	
	?>
	
		<div class="wrap">
		
			<h2><?php _e('Thank Me Later Scheduled Emails', 'thankmelater'); ?></h2>
			
			<?php _TML_addSubMenu(); ?>
			
			<?php ob_start(); /* Allows us to insert pagelinks **after** operations of DB */ ?>
			
			<table class="widefat">
				<thead>
				  <tr>
					<th scope="col" width="45%"><?php _e('Email & Comment', 'thankmelater'); ?></th>
					<th scope="col"><?php _e('Scheduled Send Time', 'thankmelater'); ?></th>
				  </tr>
				</thead>
				<tbody id="the-comment-list" class="list:comment">
				
				<?php
				
					$_items = //$itemsperpage;
								$offset+$itemsperpage; // where to end getting records
					$_offset= //$offset;
								0;
					$_todo  = $_items;
					
					$_titems = 0;
					
					while($_todo > 0):
					/* WHILE */
									
					$results = $wpdb->get_results("SELECT id, comment_ID, `date` FROM ".$_TML_Table." LIMIT ".$_offset.", ".$_todo);
					
					$_offset += $_todo;
					$_todo = 0;
			
					foreach($results as $result) { // show list of pending sends
					
						$comment = get_comment($result->comment_ID);
						
						if($comment->comment_approved != '1') {
						
							$total--;
						
							$_todo++;						
							continue; // comment is not approved
							
						}
						
						if($titems++ < $offset) continue; // only show the sends once we have got to the correct page.
						
						?>
						<tr id="pending-<?php echo $result->id; ?>" class=''>
							<td class="comment">
								<p class="comment-author">
									<strong><img alt='' src='http://www.gravatar.com/avatar/<?php echo md5($comment->comment_author_email); ?>?s=32&amp;d=http%3A%2F%2Fwww.gravatar.com%2Favatar%2Fad516503a11cd5ca435acc9bb6523536%3Fs%3D32&amp;r=G' class='avatar avatar-32' height='32' width='32' /><?php comment_author(); ?></strong><br />
								<?php if ( !empty($comment->comment_author_email) ): ?>
								<?php comment_author_email_link() ?>
								<?php endif; ?>
								</p>
								<p>
									<?php comment_text(); ?>
								</p>
								<p><?php 
								
								$post_link = "<a href='" . get_comment_link() . "'>";

								$post_link .= get_the_title($comment->comment_post_ID) . '</a>';
								
								$ptime = date('G', strtotime( $comment->comment_date ) );
								
								if ( ( abs(time() - $ptime) ) < 86400 )
									$ptime = sprintf( __('%s ago'), human_time_diff( $ptime ) );
								else
									$ptime = mysql2date(__('Y/m/d \a\t g:i A'), $comment->comment_date );
								
								printf(__('From %1$s, %2$s'), $post_link, $ptime) ?></p>
								</td>
								<td><?php echo gmdate(__('Y/m/d \\a\\t g:i A', 'thankmelater'), ( $result->date + $timeOffset ) ); ?></td>
							</tr>

						<?php
							}
							
						/* END WHILE */
						endwhile;
					
				?>
				
				<?php
				
				if($titems < $offset) {
				
				?>
				
				<tr id="pending-<?php echo $result->id; ?>" class=''>
							<td class="comment">
								<p><strong>Sorry, no results were found</strong>.</p>
								<p>This is often due because Thank Me Later estimates the number of pages for scheduled emails. You should be able to navigate the the last page, indicated above, to give you the correct last set of results.</p>
							</td>
							
				</tr>
				
				<?php } ?>
					
				
				</tbody>
			</table>
			
			<?php
			
			$c = ob_get_contents(); // buffer
			ob_end_clean();
			
			?>
			
			<div class="tablenav" style="height: 40px;">
			
				<?php
				
				/* Do this now, as we may have changed the total above */
				
					$page_links = paginate_links( array(
						'base' => add_query_arg('tml_page', '%#%'),
						'format' => '',
						'total' => ceil($total / $itemsperpage),
						'current' => $page
					));
				
				?>
			
				<?php if($page_links) { echo "<div class='tablenav-pages'>$page_links</div>"; } ?>
				<br class="clear" />
				
			</div>
			
			<?php echo $c; ?>
			
		</div>
	
	<?php
	
	/* END */
	
} /* _TML_sched() */

/* 
 *	 _TML_options_panel()
 *	Shows the options panel to view/update settings.
*/
function _TML_options_panel() {
	global $_TBL_hasOptions, $_TML_sendafter, $_TML_giveortake, $_TML_enabled, $_TML_message_from, $_TML_message_fromemail, $_TML_message_subject, $_TML_message_message, $_TML_processGroupSize, $_TML_updateInterval, $_TML_maxSend, $_TML_sendGap, $_TML_CUR_ID, $wpdb, $_TML_html, $_TML_bases, $_TML_promote, $_TML_restrict_tagsType, $_TML_restrict_tagsArr, $_TML_restrict_categoriesType, $_TML_restrict_categoriesArr;
	
	_TML_get_options(); // make sure we have the options we need...
	
	// If the user wants the history or pending page, show them that instead.
	if($_GET['p'] == 'history') {
		_TML_history();
		return;
	}elseif($_GET['p'] == 'pending') {
		_TML_sched();
		return;
	}

	if(isset($_POST['Submit'])) {
	
		check_admin_referer('thank-me-later-update-options');
		
		if($_POST['_tml_slashes'] == '\\\'') { // slashes problem
			$_POST['_tml_sendafter_time']      = stripslashes($_POST['_tml_sendafter_time']);
			$_POST['_tml_sendafter_type']      = stripslashes($_POST['_tml_sendafter_type']);
			$_POST['_tml_giveortake_time']     = stripslashes($_POST['_tml_giveortake_time']);
			$_POST['_tml_giveortake_type']     = stripslashes($_POST['_tml_giveortake_type']);
			$_POST['_tml_enabled']             = stripslashes($_POST['_tml_enabled']);
			$_POST['_tml_message_from']        = stripslashes($_POST['_tml_message_from']);
			$_POST['_tml_message_fromemail']   = stripslashes($_POST['_tml_message_fromemail']);
			$_POST['_tml_message_subject']     = stripslashes($_POST['_tml_message_subject']);
			$_POST['_tml_message_message']     = stripslashes($_POST['_tml_message_message']);
			$_POST['_tml_processGroupSize']    = stripslashes($_POST['_tml_processGroupSize']);
			$_POST['_tml_updateInterval_time'] = stripslashes($_POST['_tml_updateInterval_time']);
			$_POST['_tml_updateInterval_type'] = stripslashes($_POST['_tml_updateInterval_type']);
			$_POST['_tml_sendGap_time']        = stripslashes($_POST['_tml_sendGap_time']);
			$_POST['_tml_sendGap_type']        = stripslashes($_POST['_tml_sendGap_type']);
			$_POST['_tml_maxSend']             = stripslashes($_POST['_tml_maxSend']);
			$_POST['_tml_sampleto']            = stripslashes($_POST['_tml_sampleto']);
		}
		
		$_TML_options = array(
						'sendafter'         => (int)($_POST['_tml_sendafter_time']     * $_POST['_tml_sendafter_type']),
						'giveortake'        => (int)($_POST['_tml_giveortake_time']    * $_POST['_tml_giveortake_type']),
						'enabled'           =>      (($_POST['_tml_enabled'] == 'true') ? 'true' : 'false'),
						'message_from'      =>       $_POST['_tml_message_from'],
						'message_fromemail' =>       $_POST['_tml_message_fromemail'],
						'message_subject'   =>       $_POST['_tml_message_subject'],
						'message_message'   =>       $_POST['_tml_message_message'],
						'processGroupSize'  => (int) $_POST['_tml_processGroupSize'],
						'updateInterval'    => (int)($_POST['_tml_updateInterval_time'] * $_POST['_tml_updateInterval_type']),
						'sendGap'           => (int)($_POST['_tml_sendGap_time']        * $_POST['_tml_sendGap_type']),
						'maxSend'           => (int)($_POST['_tml_maxSend']),
						'html'              => (($_POST['_tml_html'] == 'true') ? 'true' : 'false'),
						'bases'             => array(
													'sendafter' => $_POST['_tml_sendafter_type'],
													'giveortake' => $_POST['_tml_giveortake_type'],
													'updateInterval' => $_POST['_tml_updateInterval_type'],
													'sendGap' => $_POST['_tml_sendGap_type']
												),
						'restrict_tagsType' => $_POST['_tml_restrict_tagsType'],
						'restrict_tagsArr' => array_flip(array_map('trim', explode(',', $_POST['_tml_restrict_tagsArr']))),
						'restrict_categoriesType' => $_POST['_tml_restrict_categoriesType'],
						'restrict_categoriesArr' => array_flip(array_map('trim', explode(',', $_POST['_tml_restrict_categoriesArr'])))
					);
					
		update_option('_tml_options', serialize($_TML_options));
		
		update_option('_tml_promote', ($_POST['_tml_promote'] == 'true') ? 'true' : 'false');
		
		update_option('_tml_nextUpdate', 0); // reset next update time.
		
		_TML_get_options(); // get Updated options
		
		if($_POST['_tml_sendsample'] == 'yes') { // send a sample email
		
			if($_TML_message_from && $_TML_message_fromemail)
				$from = 'From: '.$_TML_message_from.' <'.$_TML_message_fromemail.">\n";
			elseif($_TML_message_from)
				$from = 'From: '.$_TML_message_from."\n";
			elseif($_TML_message_fromemail)
				$from = 'From: '.$_TML_message_fromemail."\n";
		
			$posts = get_posts("numberposts=1&orderby=date");
			$post = $posts[0];
		
			// Create a fake, temporary comment.
			$comment = array('comment_post_ID' => $post->ID, 'comment_author' => '(Name)', 'comment_author_email' => $_POST['_tml_sampleto'], 'comment_author_url' => get_option('siteurl'), 'comment_author_IP' => $_SERVER['REMOTE_ADDR'], 'comment_date' => date('Y-m-d H:i:s'), 'comment_date_gmt' => gmdate('Y-m-d H:i:s'), 'comment_content' => 'This is just a sample comment that I\'ve written', 'comment_approved' => 1, 'comment_agent' => $_SERVER['HTTP_USER_AGENT'], 'comment_type' => '', 'comment_parent' => 0, 'user_id' => 0);
		
			$comment = get_comment(wp_insert_comment($comment), OBJECT);
			
			$_TML_CUR_ID = $comment->comment_ID;
			
			wp_mail($comment->comment_author_email, _TML_parse($_TML_message_subject, $comment), _TML_parse($_TML_message_message, $comment), $from. (($_TML_html == 'true') ? "Content-Type: text/html; charset=\"".get_bloginfo( 'charset' )."\"\n" : ''));
		
			wp_delete_comment($_TML_CUR_ID);
		
		}
		
		if($_POST['_tml_sendold'] == 'yes') { // send for old comments
			
			/* 
				This operation may be intensive for developed blogs
				Considering revision.
			*/
			
			$results = $wpdb->get_results("SELECT comment_ID, comment_approved FROM $wpdb->comments");
			
			foreach($results as $result) {
				_TML_comment_post($result->comment_ID, $result->comment_approved);
			}
	
		}
		
	}
	
	?>

	
		<div class="wrap">
		
			<h2><?php _e("Thank Me Later Configuration", 'thankmelater'); ?></h2>
			
			<?php _TML_addSubMenu(); ?>
			
			<?php if(isset($_POST['Submit'])) { ?>
				<p><div id="message" class="updated fade"><p><strong><?php _e("Your settings have been updated.", 'thankmelater'); ?></strong></p></div></p>
			<?php } ?>
			
			<!--<p><?php _e("<strong>Thank Me Later</strong> is a plug-in which will automatically send a thank you email to readers after they post a comment. It can be set to send the message a time after the comment was posted (an hour, day, week, month, etc). It is effective as it will remind readers of their comments and gets them engaged with future discussion and your blog. It is useful to attract \"one-time\" readers who will post one comment, and then forget about your blog.", 'thankmelater'); ?></p>-->
			
			<style type="text/css">
				
					small {
						color: #999999;
					}
			
			</style>
			
			<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo plugin_basename(__FILE__) ?>">
				<?php wp_nonce_field('thank-me-later-update-options'); ?>
				
				<input type="hidden" name="_tml_slashes" value="'" />
				
				<table cellspacing="7" cellpadding="5" border="0">
					
					<tr>
						<td><?php _e('From Name', 'thankmelater'); ?>:</td>
						
						<td>
							<input size="40" type="text" tabindex="2" name="_tml_message_from" value="<?php echo attribute_escape($_TML_message_from); ?> 
" /> <small><?php _e('Optional', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td><?php _e('From Email', 'thankmelater'); ?>:</td>
						
						<td>
							<input size="40" type="text" tabindex="3" name="_tml_message_fromemail" value="<?php echo attribute_escape($_TML_message_fromemail); ?>" /> <small><?php _e('Optional', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td><?php _e('Message Subject', 'thankmelater'); ?>*:</td>
						
						<td>
							<input size="40" type="text" tabindex="4" name="_tml_message_subject" value="<?php echo attribute_escape($_TML_message_subject); ?>" />
						</td>
					</tr>
					
					<tr>
						<td align="right"><input type="checkbox" tabindex="5" name="_tml_html" value="true"<?php if($_TML_html == 'true') { ?> checked="checked"<?php } ?> /></td>
						
						<td>
							<?php _e('Use HTML', 'thankmelater'); ?><br /><small><?php _e('HTML allows you to use images, links and other HTML elements in your emails. Not all clients support HTML, and some users prefer plain-text.', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td valign="top"><?php _e('Message', 'thankmelater'); ?>:</td>
						
						<td>
							<textarea name="_tml_message_message" id="_tml_message_message" tabindex="6" cols="70" rows="12"><?php echo attribute_escape($_TML_message_message); ?></textarea> <br /><small><?php _e('This message should be as personal as possible. You can use tags to refer to readers by name, and use PHP to display conditional messages.', 'thankmelater'); ?></small>							
						</td>
					</tr>
					
					<tr>
						<td valign="top"><?php _e('Templates', 'thankmelater'); ?>:</td>
						<td>
						
							<?php
							
								$dynamicMessages = array(
									array('Comment excerpt', '<?php $comment = get_comment($comment_ID, OBJECT); echo substr($comment->comment_content, 0, 30)."..."; ?>'), 
									
									array('Comment URL', '<?php $comment = get_comment($comment_ID, OBJECT); echo get_permalink($comment->comment_post_ID)."#comment-".$comment_ID; ?>'), 
									
									array('Comment Link (HTML)', '<a href="<?php $comment = get_comment($comment_ID, OBJECT); echo get_permalink($comment->comment_post_ID)."#comment-".$comment_ID; ?>">LINK TEXT HERE</a>'), 
									
									array('5 Latest Posts (<ul><li>Latest 1</li>[...]</ul>) (HTML)', '<?php query_posts("showposts=5&orderby=date"); echo "<ul>"; while (have_posts()) : the_post(); echo \'<li><a href="\'; the_permalink(); echo \'" rel="bookmark" title="\'; the_title(); echo \'">\'; the_title(); echo \'</a></li>\'; endwhile; echo "</ul>"; ?>'),
									
									array('Post Title', '<?php $comment = get_comment($comment_ID, OBJECT); $post = get_post($comment->comment_post_ID); echo $post->post_title; ?>')
									
									);
							
							?>
							
							<script type="text/javascript">
							
								var code = new Array();
								
								<?php foreach($dynamicMessages as $i => $dm) { ?>
								code[<?php echo $i; ?>] = unescape("<?php echo rawurlencode($dynamicMessages[$i][1]); ?>");
								<?php } ?>
							
								function addCode() {
								
									var append  = code[document.getElementById('_tml_dynamic_message').value];
									var message = document.getElementById('_tml_message_message');
									
									var plength = message.value.length;
								
									message.value += append;
									message.scrollTop = message.scrollHeight;
									
									message.selectionStart = plength;
									
								}
							
							</script>
						
							<select size="50" style="width: 600px; height: 150px;" id="_tml_dynamic_message">
								<?php for($i = 0, $im = count($dynamicMessages); $i < $im; $i++) { ?>
									<option value="<?php echo $i; ?>"><?php echo htmlspecialchars($dynamicMessages[$i][0]); ?></option>
								<?php } ?>
							</select> <br /><input type="button" value="Add" onclick="addCode();" /><br /><small><?php _e("This is a selection of small PHP scripts which can be used in your message.", 'thankmelater'); ?></small>
						
						</td>
					</tr>
					
					<tr>
						<td valign="top"><?php _e('Send message after', 'thankmelater'); ?>:</td>
						
						<td>
							<?php 
								$time = $_TML_sendafter;
								$time = $_TML_bases['sendafter'] ? $time/$_TML_bases['sendafter'] : $time;
								$type = $_TML_bases['sendafter'] ? $_TML_bases['sendafter']       : 1;
							?>
							<input size="7" type="text" tabindex="7" name="_tml_sendafter_time" value="<?php echo attribute_escape($time); ?>" /><select name="_tml_sendafter_type">
							<option value="1"<?php if($type == 1) { ?> selected="selected"<?php } ?>><?php _e('seconds', 'thankmelater'); ?></option>
							<option value="60"<?php if($type == 60) { ?> selected="selected"<?php } ?>><?php _e('minutes', 'thankmelater'); ?></option>
							<option value="3600"<?php if($type == 3600) { ?> selected="selected"<?php } ?>><?php _e('hours', 'thankmelater'); ?></option>
							<option value="86400"<?php if($type == 86400) { ?> selected="selected"<?php } ?>><?php _e('days', 'thankmelater'); ?></option>
							<option value="604800"<?php if($type == 604800) { ?> selected="selected"<?php } ?>><?php _e('weeks', 'thankmelater'); ?></option>
						</select>, <?php _e('give or take', 'thankmelater'); ?>
						<?php 
								$time = $_TML_giveortake;
								$time = $_TML_bases['giveortake'] ? $time/$_TML_bases['giveortake'] : $time;
								$type = $_TML_bases['giveortake'] ? $_TML_bases['giveortake']       : 1;
							?><input size="7" tabindex="8" type="text" name="_tml_giveortake_time" value="<?php echo attribute_escape($time); ?>" /><select name="_tml_giveortake_type">
							<option value="1"<?php if($type == 1) { ?> selected="selected"<?php } ?>><?php _e('seconds', 'thankmelater'); ?></option>
							<option value="60"<?php if($type == 60) { ?> selected="selected"<?php } ?>><?php _e('minutes', 'thankmelater'); ?></option>
							<option value="3600"<?php if($type == 3600) { ?> selected="selected"<?php } ?>><?php _e('hours', 'thankmelater'); ?></option>
							<option value="86400"<?php if($type == 86400) { ?> selected="selected"<?php } ?>><?php _e('days', 'thankmelater'); ?></option>
							<option value="604800"<?php if($type == 604800) { ?> selected="selected"<?php } ?>><?php _e('weeks', 'thankmelater'); ?></option>
						</select> <br /><small><?php _e('It\'s best to send a message a day or two later.', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td colspan="2">
							<p style="padding-bottom: 100px;">
								<input type="submit" name="Submit" value="<?php _e('Save Changes'); ?>" />
							</p>
							
							<h3><?php _e("Additional Settings", 'thankmelater'); ?></h3>
							
						</td>
					</tr>
					
					<tr>
						<td align="right"><input type="checkbox" tabindex="1" name="_tml_enabled" value="true"<?php if($_TML_enabled == 'true') { ?> checked="checked"<?php } ?> /></td>
						
						<td>
							<?php _e('Enabled', 'thankmelater'); ?>
						</td>
					</tr>
					
					<tr>
						<td align="right"><input type="checkbox" tabindex="7" name="_tml_sendsample" value="yes" /></td>
						
						<td>
							<?php printf(__('Send sample email to %s', 'thankmelater'), '<input type="text" name="_tml_sampleto" value="" />'); ?> <br /><small><?php _e('Select this option to see an example of your message', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td valign="top"><?php _e('Check queue every', 'thankmelater'); ?>:</td>
						
						<td>
							<?php 
								$time = $_TML_updateInterval;
								$time = $_TML_bases['updateInterval'] ? $time/$_TML_bases['updateInterval'] : $time;
								$type = $_TML_bases['updateInterval'] ? $_TML_bases['updateInterval']       : 1;
							?>
							<input size="7" tabindex="9" type="text" name="_tml_updateInterval_time" value="<?php echo attribute_escape($time); ?>" /><select name="_tml_updateInterval_type">
							<?php if($type == 1) { ?><option value="1" selected="selected"><?php _e('seconds', 'thankmelater'); ?></option><?php } ?>
							<option value="60"<?php if($type == 60) { ?> selected="selected"<?php } ?>><?php _e('minutes', 'thankmelater'); ?></option>
							<option value="3600"<?php if($type == 3600) { ?> selected="selected"<?php } ?>><?php _e('hours', 'thankmelater'); ?></option>
							<option value="86400"<?php if($type == 86400) { ?> selected="selected"<?php } ?>><?php _e('days', 'thankmelater'); ?></option>
							<option value="604800"<?php if($type == 604800) { ?> selected="selected"<?php } ?>><?php _e('weeks', 'thankmelater'); ?></option>
						</select> <br /><small><?php _e('How often should we send a batch of emails? This should be more than 10 minutes.', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td valign="top"><?php _e('Group Size', 'thankmelater'); ?>:</td>
						
						<td>
							<input size="7" tabindex="10" type="text" name="_tml_processGroupSize" value="<?php echo attribute_escape($_TML_processGroupSize); ?>" /> <br /><small><?php _e('How many records should we take from the database at any one time?', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td valign="top"><?php _e('Max. messages to single email', 'thankmelater'); ?>:</td>
						
						<td>
							<input size="7" tabindex="11" type="text" name="_tml_maxSend" value="<?php echo attribute_escape($_TML_maxSend); ?>" /> <br /><small><?php _e('How many times should we send an email to the same email address? 0 for unlimited', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td valign="top"><?php _e('Minimum gap between comments', 'thankmelater'); ?>:</td>
						
						<td>
							<?php 
								$time = $_TML_sendGap;
								$time = $_TML_bases['sendGap'] ? $time/$_TML_bases['sendGap'] : $time;
								$type = $_TML_bases['sendGap'] ? $_TML_bases['sendGap']       : 1;
							?>
							
							<?php _e('Send one thank you email for one comment every', 'thankmelater'); ?> <input tabindex="12" size="7" type="text" name="_tml_sendGap_time" value="<?php echo attribute_escape($time); ?>" /><select name="_tml_sendGap_type">
							<option value="1"<?php if($type == 1) { ?> selected="selected"<?php } ?>>seconds</option>
							<option value="60"<?php if($type == 60) { ?> selected="selected"<?php } ?>>minutes</option>
							<option value="3600"<?php if($type == 3600) { ?> selected="selected"<?php } ?>>hours</option>
							<option value="86400"<?php if($type == 86400) { ?> selected="selected"<?php } ?>>days</option>
							<option value="604800"<?php if($type == 604800) { ?> selected="selected"<?php } ?>>weeks</option>
						</select> <br /><small><?php _e('This prevents users having many of the same email being sent at once. 14 days is a good setting.', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td valign="top"><?php _e('Restrict by tags', 'thankmelater'); ?>:</td>
						
						<td>
							<select name="_tml_restrict_tagsType">
								<option value="0"<?php if(!$_TML_restrict_tagsType) { ?> selected="selected"<?php } ?>><?php _e('Include all tags <b>excluding</b> the following...', 'thankmelater'); ?></option>
								<option value="1"<?php if($_TML_restrict_tagsType) { ?> selected="selected"<?php } ?>><?php _e('Include <b>only</b> the following tags...', 'thankmelater'); ?></option>
							</select><br />
							<input type="text" name="_tml_restrict_tagsArr" value="<?php $a = false; foreach($_TML_restrict_tagsArr as $tag => $val) { if($a) echo ', '; else $a = true; echo htmlspecialchars($tag); } ?>" />
							<small><?php _e('Comma separated list of <b>tag slugs</b> to restrict/include.', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td valign="top"><?php _e('Restrict by categories', 'thankmelater'); ?>:</td>
						
						<td>
							<select name="_tml_restrict_categoriesType">
								<option value="0"<?php if(!$_TML_restrict_categoriesType) { ?> selected="selected"<?php } ?>><?php _e('Include all categories <b>excluding</b> the following...', 'thankmelater'); ?></option>
								<option value="1"<?php if($_TML_restrict_categoriesType) { ?> selected="selected"<?php } ?>><?php _e('Include <b>only</b> the following categories...', 'thankmelater'); ?></option>
							</select><br />
							<input type="text" name="_tml_restrict_categoriesArr" value="<?php $a = false; foreach($_TML_restrict_categoriesArr as $tag => $val) { if($a) echo ', '; else $a = true; echo htmlspecialchars($tag); } ?>" />
							<small><?php _e('Comma separated list of <b>category slugs</b> to restrict/include.', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td align="right"><input type="checkbox" tabindex="13" name="_tml_sendold" value="yes" /></td>
						
						<td>
							<?php _e('Send email for old comments', 'thankmelater'); ?><br /><small><?php _e('Note: You should use this feature once only. This will send a "thank you" email to authors of all previous comments. Make sure <i>Minimum gap between comments</i> is set to at least one hour, to avoid sending many messages to the same author.', 'thankmelater'); ?></small>
						</td>
					</tr>
					
					<tr>
						<td align="right"><input type="checkbox" tabindex="14" name="_tml_promote" value="true"<?php if($_TML_promote == 'true') { ?> checked="checked"<?php } ?> /></td>
						
						<td>
							<?php _e('Help promote Thank Me Later', 'thankmelater'); ?>
							<br /><small><?php _e("This will insert a small link to Thank Me Later's plugin page. Please use this if you find our plugin useful. If you don't want to link to us, why not donate instead? :)", 'thankmelater'); ?></small>
						</td>
					</tr>
					
				</table>
				
				<!-- Rules don't matter here -->
				<style type="text/css">
				
					.thankmelater_tags {
						list-style: none;
						margin: 0;
						padding: 0;
						padding-left: 30px;
					}
					
					.thankmelater_tags li {
						
					}
					.thankmelater_tags .name {
						float: left; width: 140px;
					}
				</style>
				
				<script type="text/javascript">
				
				function tml_moretoggle() {
					if(document.getElementById('_tml_moreinfo').style.display == 'none') { document.getElementById('_tml_moreinfo').style.display = ''; }else{ document.getElementById('_tml_moreinfo').style.display = 'none'; }
				}
				</script>
				
				<a href="javascript:tml_moretoggle();void(0);"><?php _e('More information', 'thankmelater'); ?></a>
				
				<div id="_tml_moreinfo" style="display: none;">
				
				
				<p>
					* <?php _e('In the subject and message fields, you can use these tags for different variables', 'thankmelater'); ?>:
					<div style="height: 150px; border: 1px solid #CCCCCC; overflow: auto;">
					<ul class="thankmelater_tags">
						<li class="name">&lt;$ID&gt;</li>
						<li><?php _e('ID of the comment', 'thankmelater'); ?></li>
						<li class="name">&lt;$POST_ID&gt;</li>
						<li><?php _e('ID of the post (article)', 'thankmelater'); ?></li>
						<li class="name">&lt;$AUTHOR&gt;</li>
						<li><?php _e('Author\'s Name', 'thankmelater'); ?></li>
						<li class="name">&lt;$AUTHOR_EMAIL&gt;</li>
						<li><?php _e('Author\'s Email Address', 'thankmelater'); ?></li>
						<li class="name">&lt;$AUTHOR_URL&gt;</li>
						<li><?php _e('Author\'s Website URL', 'thankmelater'); ?></li>
						<li class="name">&lt;$AUTHOR_IP&gt;</li>
						<li><?php _e('Author\'s IP Address', 'thankmelater'); ?></li>
						<li class="name">&lt;$DATE&gt;</li>
						<li><?php _e('Date of the comment (as YYYY-MM-DD HH:MM:SS)', 'thankmelater'); ?></li>
						<li class="name">&lt;$DATE_GMT&gt;</li>
						<li><?php _e('GMT Date of the comment (as YYYY-MM-DD HH:MM:SS)', 'thankmelater'); ?></li>
						<li class="name">&lt;$CONTENT&gt;</li>
						<li><?php _e('Content of the comment (message)', 'thankmelater'); ?></li>
						<li class="name">&lt;$KARMA&gt;</li>
						<li><?php _e('Undefined', 'thankmelater'); ?></li>
						<li class="name">&lt;$AGENT&gt;</li>
						<li><?php _e('User\'s Agent String', 'thankmelater'); ?></li>
						<li class="name">&lt;$TYPE&gt;</li>
						<li><?php _e('Type of comment', 'thankmelater'); ?></li>
						<li class="name">&lt;$PARENT&gt;</li>
						<li><?php _e('Comment\'s Parent', 'thankmelater'); ?></li>
						<li class="name">&lt;$USER_ID&gt;</li>
						<li><?php _e('User\'s ID', 'thankmelater'); ?></li>
					</ul>
					</div>
				</p>
				
				<p><?php _e("Any text in the form of <code><span style=\"color: #FF0000;\">&lt;?php</span> <span style=\"color: #FF9900;\">/* Code Here */</span> <span style=\"color: #FF0000;\">?&gt;</span></code> will be evaluated as PHP code. <span style=\"text-decoration: line-through;\">To output, you must use the <code><span style=\"color: #006600\">return</span></code> function.</span> You may now use <code><span style=\"color: #0000FF;\">echo</span></code> and <code><span style=\"color: #0000FF;\">print</span></code>. You can access the comment's ID via the variable <code>\$comment_ID</code>. For example:", 'thankmelater'); ?></p>
				
				<ul class="thankmelater_tags">
				
						<li><code><span style="color: #FF0000;">&lt;?php</span> <span style="color: #0000FF">echo</span> <span style="color: #CC0000;">"Your comment ID is $comment_ID"</span>; <span style="color: #FF0000;">?&gt;</span></code></li>
						
						<li><code>Thank you for your comment ("<span style="color: #FF0000;">&lt;?php</span> $comment = get_comment($comment_ID, OBJECT); <span style="color: #0000FF">echo</span> <span style="color: #0000FF;">substr</span>($comment<span style="color: #0000FF;">-></span>comment_content, 0, 30)<span style="color: #0000FF;">.</span><span style="color: #CC0000;">"..."</span>; <span style="color: #FF0000;">?&gt;</span>") yesterday at our blog...</code></li>
						
						<li><code>You can find your comment at this URL: <span style="color: #FF0000;">&lt;?php</span> $comment = get_comment($comment_ID, OBJECT); <span style="color: #0000FF">echo</span> get_permalink($comment<span style="color: #0000FF;">-></span>comment_post_ID)<span style="color: #0000FF;">.</span><span style="color: #CC0000;">"#comment-"</span><span style="color: #0000FF;">.</span>$comment_ID; <span style="color: #FF0000;">?&gt;</span></code></li>
						
					</ul>
					
				<p><?php _e("If you are using <strong>HTML</strong>, you will need to use <code>&lt;br /&gt;</code> for a line break.", 'thankmelater'); ?></p>
					
				<h3><?php _e("Help with Thank Me Later's Development", 'thankmelater'); ?></h3>
				
				<p><?php _e("Please give Thank Me Later a try for a few weeks. We hope it makes a difference to your blog, and increases your readership size.", 'thankmelater'); ?></p>
				
				<p><?php printf(__("If Thank Me Later has made a considerable difference, please consider %sdonating%s to support the plugin (and me ;)). A link back to my blog, %sMaking the Web%s, or your %sopinions, thoughts and ideas%s are equally valued.", 'thankmelater'), "<a href=\"https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=brendon%4022talk%2ecom&item_name=Donation+towards+%22Thank+Me+Later%22+Development&no_shipping=0&no_note=1&tax=0&currency_code=GBP&lc=GB&bn=PP%2dDonationsBF&charset=UTF%2d8 \">", "</a>", "<a href=\"http://making-the-web.com\">", "</a>", "<a href=\"http://making-the-web.com/2008/08/27/plugin-thank-me-later/\">", "</a>"); ?></p>
				
				</div>
				
				<p class="submit">
					<input type="submit" name="Submit" value="<?php _e('Save Changes'); ?>" />
				</p>
				
			</form>
			
		</div>
	<?php
} /* _TML_options_panel() */

/* 
 *	 _TML_options()
 *	Adds the option page to the "nav-bar"
*/
function _TML_options() {	
    if (function_exists('add_options_page')) {
		add_options_page('Thank Me Later', 'Thank Me Later', 8, plugin_basename(__FILE__), '_TML_options_panel');
		/*if($_GET['page'] == plugin_basename(__FILE__)) add_action('admin_notices', '_TML_addSubMenu', 1);*/
	}
} /* _TML_options() */

/* 
 *	 _TML_install()
 *	Install or updrade Thank Me Later
*/
function _TML_install() {
	global $wpdb, $_TML_SentTable, $_TML_Table, $_TBL_hasOptions, $_TML_sendafter, $_TML_giveortake, $_TML_enabled, $_TML_message_from, $_TML_message_fromemail, $_TML_message_subject, $_TML_message_message, $_TML_processGroupSize, $_TML_updateInterval, $_TML_maxSend, $_TML_sendGap, $_TML_html, $_TML_promote, $_TML_bases, $_TML_restrict_tagsType, $_TML_restrict_tagsArr, $_TML_restrict_categoriesType, $_TML_restrict_categoriesArr, $_TML_Version;

	$_TML_Table     = $_TML_Table     ? $_TML_Table     : $wpdb->prefix . "thankmelater";
	$_TML_SentTable = $_TML_SentTable ? $_TML_SentTable : $wpdb->prefix . "thankmelater_sent";
	
	delete_option('_tml_installed');
	add_option('_tml_installed','false',NULL,'yes');
	
	require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
	
	/* Determine whether we need to update the table */
	
	$structure = array(
				'id'         => array('Extra' => 'auto_increment'),
				'email_ID'    => array(),
				'comment_ID' => array('Key' => 'UNI'),
				'date'       => array()
				);
				
	$results = $wpdb->get_results("SHOW COLUMNS FROM `".$_TML_Table."`", ARRAY_A);
	
	$needsupdate = false;
	
	$tf = count($structure);
	
	foreach($results as $result) {
		if(isset($structure[$result['Field']])) {
			foreach($structure[$result['Field']] as $req => $value) {
				if($result[$req] != $value)
					$needsupdate = true;
			}
			
			$tf--;
			
		}
	}
	
	if($tf != 0) $needsupdate = true;
	
	/* End */
	
	if(($wpdb->get_var("SHOW TABLES LIKE '".$_TML_Table."'") != $_TML_Table) || $needsupdate) {
	
		$sql = "DROP TABLE IF EXISTS `".$_TML_Table."`";
	
		$wpdb->query($sql);
		
		$sql = "CREATE TABLE ".$_TML_Table." (
						`id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
						`email_ID` INT UNSIGNED NOT NULL,
						`comment_ID` INT UNSIGNED NOT NULL UNIQUE,
						`date` INT UNSIGNED NOT NULL ,
						PRIMARY KEY ( `id` ) ,
						INDEX ( `date` )
					);";
	
		dbDelta($sql);
	
	}
	
	/* Determine whether we need to update the table */
	
	$structure = array(
				'id'         => array(),
				'hash'       => array(),
				'email'      => array(),
				'sent'       => array(),
				'actualsent' => array('Key' => 'MUL'),
				'lastcomment'=> array()
				);
				
	$results = $wpdb->get_results("SHOW COLUMNS FROM `".$_TML_SentTable."`", ARRAY_A);
	
	$needsupdate = false;
	
	$tf = count($structure);
	
	foreach($results as $result) {
		if(isset($structure[$result['Field']])) {
			foreach($structure[$result->field] as $req => $value) {
				if($result[$req] != $value)
					$needsupdate = true;
			}
			
			$tf--;
			
		}
	}
	
	if($tf != 0) $needsupdate = true;
	
	/* End */
	
	if(($wpdb->get_var("SHOW TABLES LIKE '".$_TML_SentTable."'") != $_TML_SentTable) || $needsupdate) {
		
		$sql = "DROP TABLE IF EXISTS `".$_TML_SentTable."`";
	
		$wpdb->query($sql);
		
		$sql = "CREATE TABLE `".$_TML_SentTable."` (
						`id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
						`hash` INT NOT NULL,
						`email` TEXT NOT NULL ,
						`sent` SMALLINT UNSIGNED NOT NULL ,
						`actualsent` SMALLINT UNSIGNED NOT NULL,
						`lastcomment` INT UNSIGNED NOT NULL,
						PRIMARY KEY ( `id` ) ,
						INDEX ( `hash` ),
						INDEX ( `actualsent` )
					);";
	
		dbDelta($sql);
	
	}
	
	_TML_get_options();
	
	$_TML_options = array(
						'sendafter'         => ($_TML_sendafter === false)         ? 86400 : $_TML_sendafter,
						'giveortake'        => ($_TML_giveortake === false)        ? 3600 : $_TML_giveortake,
						'enabled'           => ($_TML_enabled === false)           ? 'true' : $_TML_enabled,
						'message_from'      => ($_TML_message_from === false)      ? get_bloginfo('name') : $_TML_message_from,
						'message_fromemail' => ($_TML_message_fromemail === false) ? '' : $_TML_message_fromemail,
						'message_subject'   => ($_TML_message_subject === false)   ? 'Thank you for your comment' : $_TML_message_subject,
						'message_message'   => ($_TML_message_message === false)   ? "Hi <\$AUTHOR>\n\nThank you for your message on ".get_option('blogname')." We look forward to your future communication.\n\nYou can find your comment at this URL: <?php \$comment = get_comment(\$comment_ID, OBJECT); echo get_permalink(\$comment->comment_post_ID).\"#comment-\".\$comment_ID; ?>" : $_TML_message_message,
						'processGroupSize'  => ($_TML_processGroupSize === false)  ? 100 : $_TML_processGroupSize,
						'updateInterval'    => ($_TML_updateInterval === false)    ? 1800 : $_TML_updateInterval,
						'sendGap'           => ($_TML_sendGap === false)           ? 1209600 : $_TML_sendGap,
						'maxSend'           => ($_TML_maxSend === false)           ? 0 : $_TML_maxSend,
						'html'              => ($_TML_html === false)              ? 'false' : $_TML_html,
						'bases'             => array(
													'sendafter' => ($_TML_sendafter === false)  ? 86400      : $_TML_bases['sendafter'],
													'giveortake' => ($_TML_giveortake === false)? 3600       : $_TML_bases['giveortake'],
													'updateInterval' => ($_TML_updateInterval === false)? 60 : $_TML_bases['updateInterval'],
													'sendGap' => ($_TML_sendGap === false) ? 604800          : $_TML_bases['sendGap'],
												),
												
						'restrict_tagsType' => ($_TML_restrict_tagsType === false) ? '0' : $_TML_restrict_tagsType,
						'restrict_tagsArr'  => ($_TML_restrict_tagsArr === false)  ? array() : $_TML_restrict_tagsArr,
						'restrict_categoriesType' => ($_TML_restrict_categoriesType === false) ? '0' : $_TML_restrict_categoriesType,
						'restrict_categoriesArr'  => ($_TML_restrict_categoriesArr === false)  ? array() : $_TML_restrict_categoriesArr
					);
					
	delete_option('_tml_options');
	add_option('_tml_options', serialize($_TML_options), NULL, 'no');
	
	//if(get_option("_tml_promote") === false) {
		delete_option("_tml_promote");
		add_option("_tml_promote", 'true',NULL,'yes');
	//}
	
	if(get_option("_tml_nextUpdate") === false) {
		delete_option("_tml_nextUpdate");
		add_option("_tml_nextUpdate", '0',NULL,'yes');
	}
	
	update_option('_tml_installed', $_TML_Version);
	
	wp_clear_scheduled_hook('_tml_pQSched');
	$time = time();
	wp_schedule_event($time, 'hourly', '_tml_pQSched'); // 0 mins
	wp_schedule_event($time+600, 'hourly', '_tml_pQSched'); // 10 mins
	wp_schedule_event($time+1200, 'hourly', '_tml_pQSched'); // 20
	wp_schedule_event($time+1800, 'hourly', '_tml_pQSched'); // 30
	wp_schedule_event($time+2400, 'hourly', '_tml_pQSched'); // 40
	wp_schedule_event($time+3000, 'hourly', '_tml_pQSched'); // 50
	
} /* _TML_install() */

/* 
 *	_TML_uninstall()
*/
function _TML_uninstall() {
	
} /* _TML_uninstall() */

/* 
 *	_TML_get_options()
 *	Load the options from the database and process
*/
function _TML_get_options() {
	global $_TBL_hasOptions, $_TML_sendafter, $_TML_giveortake, $_TML_enabled, $_TML_message_from, $_TML_message_fromemail, $_TML_message_subject, $_TML_message_message, $_TML_processGroupSize, $_TML_updateInterval, $_TML_maxSend, $_TML_sendGap, $_TML_html, $_TML_bases, $_TML_promote, $_TML_restrict_tagsType, $_TML_restrict_tagsArr, $_TML_restrict_categoriesType, $_TML_restrict_categoriesArr;
	
	$_TML_options = get_option('_tml_options');
	
	if(!is_array($_TML_options)) $_TML_options = unserialize($_TML_options);
	
	$_TML_sendafter               = isset($_TML_options['sendafter'])                ? $_TML_options['sendafter']               : false; 
	$_TML_giveortake              = isset($_TML_options['giveortake'])               ? $_TML_options['giveortake']              : false; 
	$_TML_enabled                 = isset($_TML_options['enabled'])                  ? $_TML_options['enabled']                 : false; 
	$_TML_message_from            = isset($_TML_options['message_from'])             ? $_TML_options['message_from']            : false; 
	$_TML_message_fromemail       = isset($_TML_options['message_fromemail'])        ? $_TML_options['message_fromemail']       : false; 
	$_TML_message_subject         = isset($_TML_options['message_subject'])          ? $_TML_options['message_subject']         : false; 
	$_TML_message_message         = isset($_TML_options['message_message'])          ? $_TML_options['message_message']         : false; 
	$_TML_processGroupSize        = isset($_TML_options['processGroupSize'])         ? $_TML_options['processGroupSize']        : false; 
	$_TML_updateInterval          = isset($_TML_options['updateInterval'])           ? $_TML_options['updateInterval']          : false; 
	$_TML_maxSend                 = isset($_TML_options['maxSend'])                  ? $_TML_options['maxSend']                 : false; 
	$_TML_sendGap                 = isset($_TML_options['sendGap'])                  ? $_TML_options['sendGap']                 : false;
	$_TML_html                    = isset($_TML_options['html'])                     ? $_TML_options['html']                    : false;
	$_TML_bases                   = isset($_TML_options['bases'])                    ? $_TML_options['bases']                   : false;
	$_TML_restrict_tagsType       = isset($_TML_options['restrict_tagsType'])        ? $_TML_options['restrict_tagsType']       : false;
	$_TML_restrict_tagsArr        = isset($_TML_options['restrict_tagsArr'] )        ? $_TML_options['restrict_tagsArr']        : false;
	$_TML_restrict_categoriesType = isset($_TML_options['restrict_categoriesType'])  ? $_TML_options['restrict_categoriesType'] : false;
	$_TML_restrict_categoriesArr  = isset($_TML_options['restrict_categoriesArr'] )  ? $_TML_options['restrict_categoriesArr']  : false;
	
	$_TML_promote = get_option('_tml_promote');
} /* _TML_get_options() */

$_TML_CUR_ID = 0; // stores the current comment ID for use by _TML_eval()

/* 
 *	_TML_eval()
 *	Evaluates PHP code in the message area
*/
function _TML_eval($php) {
	global $_TML_CUR_ID;
	$php = $php[1];
	$php = '$comment_ID = '.$_TML_CUR_ID.';'.$php;
	
	ob_start();
	$ret = eval($php);
	if(!$ret) {
		$ret = ob_get_contents();
	}
	ob_end_clean();
	
	return $ret;
} /* _TML_eval() */

/* 
 *	_TML_parse()
 *	Parses message data to evaluate PHP, and replace tags with corresponding values
*/
function _TML_parse($text, $comment) {
	
	global $_TML_html;
	
	$text = preg_replace_callback('/<\?php((.|\n|\r)*?)\?>/', '_TML_eval', $text);
	
	$replacewith = array($comment->comment_ID, $comment->comment_post_ID, $comment->comment_author, $comment->comment_author_email, $comment->comment_author_url, $comment->comment_author_IP, $comment->comment_date , $comment->comment_date_gmt, $comment->comment_content, $comment->comment_karma, $comment->comment_approved, $comment->comment_agent, $comment->comment_type, $comment->comment_parent, $comment->user_id);
	
	// replace variables	
	if($_TML_html == 'true') 
		$replacewith = array_map('htmlspecialchars', $replacewith);
	
	$text = str_replace(array('<$ID>','<$POST_ID>','<$AUTHOR>','<$AUTHOR_EMAIL>','<$AUTHOR_URL>','<$AUTHOR_IP>','<$DATE>','<$DATE_GMT>','<$CONTENT>','<$KARMA>','<$APPROVED>','<$AGENT>','<$TYPE>','<$PARENT>','<$USER_ID>'), $replacewith, $text);
	
	return $text;
} /* _TML_parse() */

/* 
 *	_TML_ShiftLeftAs32()
 *	Left shifts as if we are using a 32-bit system (in case we are using a 64-bit system)
*/
function _TML_ShiftLeftAs32($val, $l) { /* 32 bit shift */
	$val = str_pad(decbin($val) . str_repeat(0, $l), 32, 0, STR_PAD_LEFT);
	$val = substr($val, strlen($val)-32);
	
	if($val[0] == '1')
		return bindec(substr($val, 1)) -2147483648;
		
	return bindec($val);
} /* _TML_ShiftLeftAs32() */

/* 
 *	_TML_hashint()
 *	Calculates a numbers which represents part of a MD5 hash. For use in searching tables quickly.
*/
function _TML_hashint($text) {
	$hash = pack('H*', md5($text));
		
	$hash = 
		  _TML_ShiftLeftAs32(ord($hash[0]), 24)
		+ _TML_ShiftLeftAs32(ord($hash[1]), 16)
		+ _TML_ShiftLeftAs32(ord($hash[2]), 8)
		+(ord($hash[3]));
		
	return $hash;
} /* _TML_hashint() */

/* 
 *	_TML_processQueue()
 *	Send the emails in the queue, if they have passed their send date
*/
function _TML_processQueue() {
	global $wpdb, $_TML_Table, $_TML_SentTable, $_TBL_hasOptions, $_TML_sendafter, $_TML_giveortake, $_TML_enabled, $_TML_message_from, $_TML_message_fromemail, $_TML_message_subject, $_TML_message_message, $_TML_processGroupSize, $_TML_updateInterval, $_TML_CUR_ID, $_TML_maxSend, $_TML_sendGap, $_TML_html;

	set_time_limit(0); // Processing the queue will take a while
	
	_TML_get_options();
	
	if($_TML_enabled != 'true') return;
	
	$time = time();
	
	if($_TML_message_from && $_TML_message_fromemail)
		$from = 'From: '.$_TML_message_from.' <'.$_TML_message_fromemail.">\n";
	elseif($_TML_message_from)
		$from = 'From: '.$_TML_message_from."\n";
	elseif($_TML_message_fromemail)
		$from = 'From: '.$_TML_message_fromemail."\n";
	
	while(true) {
	
		$query = "SELECT `id`, `email_ID`, `comment_ID`, `date` FROM $_TML_Table WHERE `date` < $time LIMIT 0, $_TML_processGroupSize";
		
		$results = $wpdb->get_results($query);
		
		if(!isset($results[0])) break; // there are no results.
		
		$deletequery = '';
		
		$htmlContentType = "Content-Type: text/html; charset=\"".get_bloginfo( 'charset' )."\"\n";
		
		foreach($results as $result) {
		
			$comment = get_comment($result->comment_ID, OBJECT);
			
			$deletequery .= ','.$result->id;
			
			if($comment->comment_approved != '1') {
			
				$hash = _TML_hashint($comment->comment_author_email);
			
				$queryr = "UPDATE $_TML_SentTable SET sent=GREATEST(sent-1, 0) WHERE `id` = ".$result->email_ID;
	
				$wpdb->query($queryr);
				
				$queryr = "DELETE FROM $_TML_SentTable WHERE `id` = ".$result->email_ID." AND `sent` = 0"; // delete if no emails have been sent/are scheduled
		
				$resultr = $wpdb->query($query);
			
				continue; // comment is not approved
			}
			
			$queryr = "UPDATE $_TML_SentTable SET actualsent=actualsent+1 WHERE `id` = ".$result->email_ID;
	
			$wpdb->query($queryr);
			
			$_TML_CUR_ID = $comment->comment_ID;
			
			wp_mail($comment->comment_author_email, _TML_parse($_TML_message_subject, $comment), _TML_parse($_TML_message_message, $comment), $from. (($_TML_html == 'true') ? $htmlContentType : ''));
		
		}
		
		$affected = $wpdb->query("DELETE FROM $_TML_Table WHERE `id` IN (".substr($deletequery, 1).")");
		if(!$affected) return; // safeguard: if we can not delete the rows, we'll be in this endless loop forever.
		
		$deletequery = '';
		
	}
	
	
} /* _TML_processQueue() */

/* 
 *	_TML_checkRestriction()
 *	Check if the tag/category conditions are met, and return the result.
*/
function _TML_checkRestriction($type, $listA, $listB) {
	switch($type) {
		case 0: // exlude the following
			foreach($listA as $obj) {
				if(isset($listB[$obj->slug])) {
					return; // the tag/cat is exluded!
				}
			}
		break;
		case 1: // include the follow ONLY...
			$hasTag = false;
			foreach($listA as $obj) {
				if(isset($listB[$obj->slug])) {
					$hasTag = true;
				}
			}
			if(!$hasTag) return; // the post does not share common tag/cat
		break;
	}
	return true; // all ok
} /* _TML_checkRestriction() */

/* 
 *	_TML_comment_post()
 *	Processes a comment after it has been processed. Adds the comment to TML's queue
*/
function _TML_comment_post($id, $status) {
	global $wpdb, $_TML_enabled, $_TML_SentTable, $_TML_Table, $_TML_sendafter, $_TML_giveortake, $_TML_maxSend, $_TML_sendGap, $_TML_restrict_tagsType, $_TML_restrict_tagsArr, $_TML_restrict_categoriesType, $_TML_restrict_categoriesArr;
	
	_TML_get_options();
	
	if($_TML_enabled != 'true') return;
	
	$time = time();
	
	$comment = get_comment($id, OBJECT);
	
	$post = query_posts('p='.$comment->comment_post_ID);
	
	the_post();
	
	$tags = get_the_tags();
	
	// check restrictions for TAGS
	if(!_TML_checkRestriction($_TML_restrict_tagsType, $tags, $_TML_restrict_tagsArr)) return;
	
	$cats = get_the_category();
	
	// check restrictions for CATEGORIES
	if(!_TML_checkRestriction($_TML_restrict_categoriesType, $cats, $_TML_restrict_categoriesArr)) return;
	
	if($comment->comment_type != "") return;
	
	$hash = _TML_hashint($comment->comment_author_email);
	
	$query = $wpdb->prepare("SELECT `id`, `hash`, `email`, `sent`, `lastcomment` FROM $_TML_SentTable WHERE `hash` = ".$hash." AND `email` = %s", $comment->comment_author_email);
	
	$result = $wpdb->get_row($query, OBJECT);
	
	$emailid = 0;
	
	if($result) {
	
		$emailid = $result->id;
		
		if($_TML_maxSend)
			if($result->sent >= $_TML_maxSend)
				return;
		if($_TML_sendGap)
			if($result->lastcomment+$_TML_sendGap > $time)
				return;
				
		$query = $wpdb->prepare("UPDATE $_TML_SentTable SET sent=sent+1, lastcomment = ".$time." WHERE `hash` = ".$hash." AND `email` = %s", $comment->comment_author_email);
	
		$wpdb->query($query);
		
	}else{
	
		$query = $wpdb->prepare("INSERT INTO $_TML_SentTable (`hash`, `email`, `sent`, `actualsent`, `lastcomment`) VALUES (".$hash.", %s, 1, 0, ".$time.")", $comment->comment_author_email);
	
		$result = $wpdb->get_row($query);
		
		$emailid = $wpdb->insert_id;
		
	}
	
	$time += $_TML_sendafter - $_TML_giveortake;
	$time+= rand(0, $_TML_giveortake*2);
	
	$query = $wpdb->prepare("INSERT INTO $_TML_Table (email_ID, comment_ID, date) VALUES (%d, $id, $time)", $emailid);
	
	$result = $wpdb->query($query);
	
} /* _TML_comment_post() */

/* 
 *	_TML_delete_comment()
 *	Deletes a comment from the queue after it is removed (ie, spam comments being deleted)
*/
function _TML_delete_comment($id) {
	global $_TML_Table, $wpdb;

	$queryr = "DELETE FROM $_TML_Table WHERE `comment_ID` = ".intval($id); // delete from the queue.
	
	$wpdb->query($queryr);
} /* _TML_delete_comment() */

/* 
 *	_TML_init()
 *	Initializes everything. Checks install version, loads language data and checks whether queue needs processing.
*/
function _TML_init() {
	global $_TML_updateInterval, $_TML_Version;
	
	if(get_option('_tml_installed') != $_TML_Version) {
		_TML_install();
	}
	
	load_plugin_textdomain('thankmelater', "/wp-content/plugins/".dirname(plugin_basename(__FILE__))); // we'll need the language data
	
	/*if((get_option('_tml_nextUpdate') < time()) && (get_option('_tml_nextUpdate') !== false)) {
	
		_TML_get_options();
	
		update_option('_tml_nextUpdate', time()+$_TML_updateInterval);
		
		// Note: the following will not work when using localhost.		
		wp_schedule_single_event(time(), '_TML_processQueuehook'); //run in the background
	}	*/
	
} /* _TML_init() */

/* 
 *	_TML_addSubMenu()
 *	Initializes everything. Checks install version, loads language data and checks whether queue needs processing.
*/
function _TML_addSubMenu() {
	?>
		<ul id="submenu" class="subsubsub">
			<?php
				$page = '';
				switch($_GET['p']) {
					case 'history':
						$page = 'history';
					break;
					case 'pending':
						$page = 'pending';
					break;
					default:
						$page = 'options';
					break;
				}
			?>
			<li><a href="?page=<?php echo urlencode(plugin_basename(__FILE__)); ?>&p=options"<?php if($page == 'options') { ?> class="current"<?php } ?>><?php _e('Options', 'thankmelater'); ?></a> |</li>
			<li><a href="?page=<?php echo urlencode(plugin_basename(__FILE__)); ?>&p=history"<?php if($page == 'history') { ?> class="current"<?php } ?>><?php _e('Sent History', 'thankmelater'); ?></a> |</li>
			<li><a href="?page=<?php echo urlencode(plugin_basename(__FILE__)); ?>&p=pending"<?php if($page == 'pending') { ?> class="current"<?php } ?>><?php _e('Scheduled Emails', 'thankmelater'); ?></a></li>			
		</ul>
		<div class="clear"></div>
	<?php
} /* _TML_addSubMenu() */

/* 
 *	_TML_promote()
 *	Adds "powered by Thank Me Later" or similar link below comment form
*/
function _TML_promote($postid = 0) {
	echo '<p><div>We use <a href="http://making-the-web.com/thank-me-later/" title="Powered by Wordpress plugin, Thank Me Later" rel="nofollow">Thank Me Later</a>.</div></p>';
} /* _TML_promote() */

add_action('_TML_processQueuehook', '_TML_processQueue');
add_action('admin_menu', '_TML_options', 20);
add_action('activate_'.plugin_basename(__FILE__), '_TML_install');
add_action('deactivate_'.plugin_basename(__FILE__),'_TML_uninstall');
add_action('init', '_TML_init');
add_action('comment_post', '_TML_comment_post', 10, 2);
add_action('delete_comment', '_TML_delete_comment', 10, 2);

if(get_option('_tml_promote') == 'true') {
	add_action('comment_form', '_TML_promote', 10, 2);
}

function _TML_tick() {
	global $_TML_updateInterval;

	if((get_option('_tml_nextUpdate') < time()) && (get_option('_tml_nextUpdate') !== false)) {
		_TML_processQueue();
		update_option('_tml_nextUpdate', time()+$_TML_updateInterval);
	}
	
}

add_action('_tml_pQSched', '_TML_tick');

?>